'use strict';

exports.__esModule = true;
exports.default = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactPageClick = require('react-page-click');

var _reactPageClick2 = _interopRequireDefault(_reactPageClick);

var _styledComponents = require('styled-components');

var _token = require('./utils/token');

var _dropdown = require('./components/dropdown');

var _dropdown2 = _interopRequireDefault(_dropdown);

var _index = require('./index.styl');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _default = (_temp = _class = function (_Component) {
  _inherits(_default, _Component);

  function _default(props) {
    _classCallCheck(this, _default);

    var _this = _possibleConstructorReturn(this, _Component.call(this, props));

    _this.keydown = _this.keydown.bind(_this);
    _this.handleEnterKey = _this.handleEnterKey.bind(_this);
    _this.onChange = _this.onChange.bind(_this);
    _this.onSelect = _this.onSelect.bind(_this);
    _this.onAutosuggest = _this.onAutosuggest.bind(_this);
    _this.onSelectValue = _this.onSelectValue.bind(_this);
    _this.shouldAutosuggest = _this.shouldAutosuggest.bind(_this);
    _this.onClose = _this.onClose.bind(_this);
    _this.onClickToken = _this.onClickToken.bind(_this);
    _this.getCurrentChunk = _this.getCurrentChunk.bind(_this);
    _this.extractTokens = _this.extractTokens.bind(_this);
    _this.buildOverlay = _this.buildOverlay.bind(_this);
    _this.state = {
      loading: true,
      value: props.defaultValue || '',
      attributes: [],
      overlayComponents: [],
      dropdownOpen: false,
      dropdownValue: null,
      dropdownX: null,
      dropdownY: null
    };
    return _this;
  }

  _default.prototype.componentDidMount = function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              document.addEventListener('keydown', this.keydown, false);

              _context.prev = 1;
              _context.t0 = this;
              _context.next = 5;
              return this.props.getData();

            case 5:
              _context.t1 = _context.sent;
              _context.t2 = {
                attributes: _context.t1,
                loading: false
              };

              _context.t0.setState.call(_context.t0, _context.t2);

              _context.next = 13;
              break;

            case 10:
              _context.prev = 10;
              _context.t3 = _context['catch'](1);

              console.error('Error while getting data:', _context.t3);

            case 13:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, this, [[1, 10]]);
    }));

    function componentDidMount() {
      return _ref.apply(this, arguments);
    }

    return componentDidMount;
  }();

  _default.prototype.componentWillUnmount = function componentWillUnmount() {
    document.removeEventListener('keydown', this.keydown, false);
  };

  _default.prototype.componentDidUpdate = function componentDidUpdate(prevProps, prevState) {
    var _state = this.state,
        value = _state.value,
        attributes = _state.attributes;


    if (value !== prevState.value || attributes.length !== prevState.attributes.length) {
      this.setState({
        overlayComponents: this.buildOverlay(value)
      });
    }
  };

  _default.prototype.keydown = function keydown(evt) {
    switch (evt.keyCode) {
      case 13:
        // enter key
        this.handleEnterKey(evt);
        break;
    }
  };

  _default.prototype.handleEnterKey = function handleEnterKey(evt) {
    // whether this input is infocus
    var isFocused = document.activeElement === this._input;

    // submit on enter, line break on shift enter
    // dropdown handles enter key as well, so prevent clash
    if (!evt.shiftKey && isFocused && !this.state.dropdownOpen) {
      evt.preventDefault();
      this.props.onSubmit(this.state.value);
    }
  };

  _default.prototype.onChange = function onChange(evt) {
    this.setState({
      value: evt.target.value
    }, this.onAutosuggest);
  };

  _default.prototype.onSelect = function onSelect(evt) {
    var value = evt.target.value;


    this.setState({
      overlayComponents: this.buildOverlay(value)
    }, this.onAutosuggest);
  };

  _default.prototype.onAutosuggest = function onAutosuggest() {
    var value = this.state.value;
    var _marker = this._marker,
        offsetLeft = _marker.offsetLeft,
        offsetTop = _marker.offsetTop;

    var _getCurrentChunk = this.getCurrentChunk(value),
        chunk = _getCurrentChunk.chunk;

    var suggest = this.shouldAutosuggest(chunk);

    if (suggest) {
      this.setState({
        dropdownOpen: true,
        dropdownValue: chunk,
        dropdownX: offsetLeft,
        dropdownY: offsetTop + 25 // line height + 5 extra padding
      });
    } else {
      this.setState({
        dropdownOpen: false
      });
    }
  };

  _default.prototype.onSelectValue = function onSelectValue(chunk) {
    var _this2 = this;

    var appended = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
    var value = this.state.value;

    var _getCurrentChunk2 = this.getCurrentChunk(value),
        index = _getCurrentChunk2.index,
        indexEnd = _getCurrentChunk2.indexEnd;

    var before = value.slice(0, index);
    var after = value.slice(indexEnd);
    var position = index + chunk.length + appended.length;
    var positionEnd = position + after.length;

    this.setState({
      value: appended === ' ' && position < positionEnd ? '' + before + chunk + after : '' + before + chunk + appended + after
    }, function () {
      // position caret at the end of the inserted value
      _this2._input.focus();
      _this2._input.setSelectionRange(position, position);
    });
  };

  _default.prototype.shouldAutosuggest = function shouldAutosuggest(chunk) {
    var selectionStart = this._input.selectionStart;
    var value = this.state.value;

    // next character is whitespace, closing paren or null

    var nextCharIsEmpty = !value.charAt(selectionStart) || /[)\s]/.test(value.charAt(selectionStart));

    // whitespace/negation/paren before and whitespace after caret
    var isNewWord = nextCharIsEmpty && /[\s-(]/.test(value.charAt(selectionStart - 1));

    // cursor is at end of the current word
    var atEndOfWord = nextCharIsEmpty && /[^)\s]/.test(value.charAt(selectionStart - 1));

    // make sure we're not inside a quoted value in token
    var parsed = (0, _token.parseToken)(chunk, { partial: true });
    var inQuotedToken = parsed.attributeValue && parsed.attributeValue.indexOf('"') > -1;

    return !value || isNewWord || atEndOfWord && !inQuotedToken;
  };

  _default.prototype.onClose = function onClose() {
    this.setState({
      dropdownOpen: false
    });
  };

  _default.prototype.onClickToken = function onClickToken(start, end) {
    // move cursor to end of token
    this._input.focus();
    this._input.setSelectionRange(end, end);
  };

  _default.prototype.getCurrentChunk = function getCurrentChunk(value) {
    var selectionStart = this._input.selectionStart;

    // get location of each token found in value

    var tokens = this.extractTokens(value);

    // find index of the closest previous whitespace
    var prevStr = value.substring(0, selectionStart);
    var prevMatch = prevStr.match(/[^\s]*$/);
    var prevIdx = prevMatch ? prevStr.lastIndexOf(prevMatch[prevMatch.length - 1]) : -1;

    // determine correct index for the start of the chunk
    var index = prevIdx;
    for (var _iterator = tokens.reverse(), _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _iterator[Symbol.iterator]();;) {
      var _ref3;

      if (_isArray) {
        if (_i >= _iterator.length) break;
        _ref3 = _iterator[_i++];
      } else {
        _i = _iterator.next();
        if (_i.done) break;
        _ref3 = _i.value;
      }

      var _ref2 = _ref3;
      var start = _ref2[0];
      var end = _ref2[1];

      // token is between whitespace and cursor
      if (selectionStart > end && prevIdx < start) {
        index = end;
        break;
      }
      // at the end of or inside a token (thats what she said)
      if (selectionStart > start && selectionStart <= end) {
        index = start;
        break;
      }
      // there is whitespace in the token
      if (prevIdx > start && prevIdx < end) {
        index = end;
        break;
      }
    }

    // value is result of cursor back to beginning of chunk
    var chunk = value.substring(index, selectionStart);
    var indexEnd = index + chunk.length;

    return {
      index: index,
      indexEnd: indexEnd,
      chunk: chunk
    };
  };

  _default.prototype.extractTokens = function extractTokens(value) {
    var positions = [];
    var regex = (0, _token.tokenRegex)();

    var result = void 0;
    while ((result = regex.exec(value)) !== null) {
      var parsed = (0, _token.parseToken)(result, {
        attributes: this.state.attributes
      });

      if (!parsed.attributeNameValid || !parsed.attributeValueValid) {
        continue;
      }

      // if there is paren before token, don't include it in highlight
      var shiftStartPosition = result[0].search(/[^(]/);

      var startPosition = result.index + shiftStartPosition;
      var endPosition = regex.lastIndex;

      positions.push([startPosition, endPosition]);
    }

    return positions;
  };

  _default.prototype.buildTokens = function buildTokens(value) {
    var _this3 = this;

    var relativeToIdx = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;

    var chunks = [];
    var positions = this.extractTokens(value);

    var currentPosition = 0;
    positions.reduce(function (prev, next) {
      var startIdx = next[0] + relativeToIdx;
      var endIdx = next[1] + relativeToIdx;

      chunks.push(value.substring(prev[1], next[0]));
      chunks.push(_react2.default.createElement(
        _index.Token,
        {
          key: 'token-' + next[0],
          onClick: function onClick() {
            return _this3.onClickToken(startIdx, endIdx);
          } },
        value.substring(next[0], next[1])
      ));

      currentPosition = next[1];
      return next;
    }, [null, 0]);

    chunks.push(value.substring(currentPosition));
    return chunks;
  };

  _default.prototype.buildOverlay = function buildOverlay(value) {
    var _this4 = this;

    // figure out where we should split the overlay,
    // so we know where to position the dropdown
    var _getCurrentChunk3 = this.getCurrentChunk(value),
        index = _getCurrentChunk3.index;

    // everything to the left of the current word/token


    var stuffOnLeft = this.buildTokens(value.substring(0, index));

    // everything to the right of the current word/token
    // need to have default whitespace or dropdown will not find position of caret
    var stuffOnRight = this.buildTokens(value.substring(index) || ' ', index);

    // since it will never split up a token,
    // we can build each side of cursor independently
    return [stuffOnLeft, _react2.default.createElement(
      _index.Inline,
      {
        key: 'after-' + index,
        style: { outline: this.props.debug ? '1px solid red' : 'none' },
        innerRef: function innerRef(ref) {
          return _this4._marker = ref;
        } },
      stuffOnRight
    )];
  };

  _default.prototype.render = function render() {
    var _this5 = this;

    var inputTheme = _extends({
      background: '#FFFFFF',
      border: '1px solid rgba(0, 0, 0, .1)',
      color: '#505050',
      placeholderColor: '#D7D7D7',
      tokenColor: '#2384FF',
      fontFamily: '"Courier New", Courier, monospace'
    }, this.props.inputTheme);

    var dropdownTheme = _extends({
      background: '#555555',
      backgroundActive: '#FFFFFF',
      borderActive: '1px solid #AAAAAA',
      boxShadow: '0 4px 10px rgba(0, 0, 0, .25)',
      color: '#FFFFFF',
      colorActive: '#000000',
      minWidth: '270px'
    }, this.props.dropdownTheme);

    return _react2.default.createElement(
      _reactPageClick2.default,
      {
        outsideOnly: true,
        notify: this.onClose },
      _react2.default.createElement(
        _index.Container,
        {
          className: this.props.className },
        _react2.default.createElement(
          _styledComponents.ThemeProvider,
          {
            theme: inputTheme },
          _react2.default.createElement(
            _index.InputContainer,
            null,
            _react2.default.createElement(
              _index.Overlay,
              null,
              this.state.overlayComponents
            ),
            _react2.default.createElement(_index.Input, {
              autoComplete: 'off',
              autoCorrect: 'off',
              autoCapitalize: 'off',
              spellCheck: 'false',
              placeholder: this.props.placeholder,
              value: this.state.value,
              onChange: this.onChange,
              onSelect: this.onSelect,
              inputRef: function inputRef(ref) {
                return _this5._input = ref;
              } })
          )
        ),
        this.state.dropdownOpen && !this.state.loading && _react2.default.createElement(
          _styledComponents.ThemeProvider,
          {
            theme: dropdownTheme },
          _react2.default.createElement(_dropdown2.default, {
            keyboardHelpers: this.props.keyboardHelpers,
            footerComponent: this.props.footerComponent,
            attributes: this.state.attributes,
            value: this.state.dropdownValue,
            onSelect: this.onSelectValue,
            onClose: this.onClose,
            offsetX: this.state.dropdownX,
            offsetY: this.state.dropdownY })
        )
      )
    );
  };

  return _default;
}(_react.Component), _class.propTypes = { // eslint-disable-line
  debug: _propTypes2.default.bool,
  defaultValue: _propTypes2.default.string,
  placeholder: _propTypes2.default.string,
  getData: _propTypes2.default.func,
  onSubmit: _propTypes2.default.func,
  keyboardHelpers: _propTypes2.default.bool,
  footerComponent: _propTypes2.default.func,
  inputTheme: _propTypes2.default.object,
  dropdownTheme: _propTypes2.default.object
}, _class.defaultProps = { // eslint-disable-line
  getData: function getData() {
    return Promise.resolve([]);
  },
  onSubmit: console.log,
  placeholder: 'Search',
  inputTheme: {},
  dropdownTheme: {}
}, _temp);

exports.default = _default;
module.exports = exports['default'];